---
title: Intl.RelativeTimeFormat.prototype.formatToParts()
slug: Web/JavaScript/Reference/Global_Objects/Intl/RelativeTimeFormat/formatToParts
tags:
  - Internationalization
  - Intl
  - JavaScript
  - Method
  - Prototype
  - RelativeTimeFormat
---
<div>{{JSRef}}</div>

<p>The <code>Intl.RelativeTimeFormat.prototype.formatToParts()</code> method returns an {{jsxref("Array")}} of objects representing the relative time format in parts that can be used for custom locale-aware formatting.</p>

<div>{{EmbedInteractiveExample("pages/js/intl-relativetimeformat-prototype-formattoparts.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js"><code>RelativeTimeFormat.formatToParts(value, unit)</code></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>value</code></dt>
 <dd>Numeric value to use in the internationalized relative time message.</dd>
</dl>

<dl>
 <dt><code>unit</code></dt>
 <dd>Unit to use in the relative time internationalized message. Possible values are: <code>"year"</code>, <code>"quarter"</code>, <code>"month", "week", "day", "hour", "minute", "second"</code>. Plural forms are also permitted.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{jsxref("Array")}} of objects containing the formatted relative time in parts.</p>

<h2 id="Description">Description</h2>

<div>The <code>Intl.RelativeTimeFormat.prototype.formatToParts</code> method is a version of the format method which it returns an array of objects which represent "parts" of the object, separating the formatted number into its consituent parts and separating it from other surrounding text. These objects have two properties: type a <code>NumberFormat</code> formatToParts type, and value, which is the String which is the component of the output. If a "part" came from <code>NumberFormat</code>, it will have a unit property which indicates the unit being formatted; literals which are part of the larger frame will not have this property.</div>

<h2 id="Examples">Examples</h2>

<h3 id="Using_formatToParts">Using formatToParts</h3>

<pre class="brush: js">const rtf = new Intl.RelativeTimeFormat("en", { numeric: "auto" });

// Format relative time using the day unit
rtf.formatToParts(-1, "day");
// &gt; [{ type: "literal", value: "yesterday"}]

rtf.formatToParts(100, "day");
// &gt; [{ type: "literal", value: "in " },
// &gt;  { type: "integer", value: "100", unit: "day" },
// &gt;  { type: "literal", value: " days" }]</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('ES Int Draft', '#sec-Intl.RelativeTimeFormat.prototype.formatToParts', 'RelativeTimeFormat.formatToParts()')}}</td>
   <td>Stage 4</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Intl.RelativeTimeFormat.formatToParts")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("RelativeTimeFormat", "Intl.RelativeTimeFormat")}}</li>
</ul>
